//----------------------------------------------------------------------------------
//----------------------------------------------------------------------------------
//Praktická Elektronika - MSP430 seriál, časť VI.
//Druhý príklad: pripojenie LCD
//----------------------------------------------------------------------------------
//----------------------------------------------------------------------------------

#include <LiquidCrystal.h>                             //(1) include LCD communication library
LiquidCrystal lcd(P1_0, P1_1, P1_2, P1_3, P1_4, P1_5); //(2) define the connection to LCD
unsigned long int v_counter = 0;                       //(3) define counter variable
// ----------------------------------------------------------------------------------------------------------------
// ----------------------------------------------------------------------------------------------------------------
void setup()                                           //(4) Setup function
{
  lcd.begin(20, 4);                                    //(5) set-up usage of 4 rows x 20 columns

  lcd.setCursor(0,0);                                  //(6) put cursor to position col:0 / row:0
  lcd.print("MSP430 Basics");                          //(7) write the text in quotes starting at 0,0
  lcd.setCursor(0,1);                                  //(8) put cursor to position col:0 / row:1
  lcd.print("MCU: MSP430G2553");                       //(9) write the text in quotes starting at 0,1
  lcd.setCursor(0,2);                                  //(10) put cursor to position col:0 / row:2
  lcd.print("Example 7");                              //(11) write the text in quotes starting at 0,2
  lcd.setCursor(0,3);                                  //(12) put cursor to position col:0 / row:3
  lcd.print("25.03.2021");                             //(13) write the text in quotes starting at 0,3

  delay(3000);                                         //(14) wait 3 sec
  lcd.clear();                                         //(15) clear the content of the LCD
}
// ----------------------------------------------------------------------------------------------------------------
// ----------------------------------------------------------------------------------------------------------------
void loop()                                            //(16) main loop starts here
{
  lcd.setCursor(0,0);                                  //(17) put cursor to position col:0 / row:0
  lcd.print("LCD connection");                         //(18) write the text in quotes starting at 0,0
  lcd.setCursor(0,1);                                  //(19) put cursor to position col:0 / row:1
  lcd.print("Version: Energia");                       //(20) write the text in quotes starting at 0,1
  lcd.setCursor(0,2);                                  //(21) put cursor to position col:0 / row:2
  lcd.print("here is a counter:");                     //(22) write the text in quotes starting at 0,2
  w_print(3,3);                                        //(23) show counter information
  v_counter++;                                         //(24) increment counter
  if (v_counter > 99999) v_counter = 0;                //(25) put counter to 0 if we cross the border
}
// ----------------------------------------------------------------------------------------------------------------
// ----------------------------------------------------------------------------------------------------------------
void w_print(byte iv_col, byte iv_row)                 //(26) writing counter stage
                                                       //     always 5 places (with leading zeros)
{
  lcd.setCursor(iv_col,iv_row);                        //(27) put cursor to position col:3 / row:3
  lcd.print("==> ");                                   //(28) write the text in quotes starting at 3,3
  if (v_counter < 10000) lcd.print("0");               //(29) for number under 10.000: write zero on this position
  if (v_counter < 1000 ) lcd.print("0");               //(30) for number under  1.000: write zero on this position
  if (v_counter < 100  ) lcd.print("0");               //(31) for number under    100: write zero on this position
  if (v_counter < 10   ) lcd.print("0");               //(32) for number under     10: write zero on this position
  lcd.print(v_counter);                                //(33) show the counter value
  lcd.print(" <==");                                   //(34) write the text in quotes
}
// ----------------------------------------------------------------------------------------------------------------
// ----------------------------------------------------------------------------------------------------------------
